<?php 
header("Content-Type: application/pdf");
//header("Content-Disposition: attachment; filename=\"prueba.pdf\"");

require_once 'Zend/Pdf.php';

function creaPagina() {
global $pdf;
global $tamaño_letra;
global $font;
	$pdf->pages[] = ($pagina = $pdf->newPage('A4'));
	
	// Creamos el estilo de la fuente
	$estilo = new Zend_Pdf_Style();
	$estilo->setFillColor(new Zend_Pdf_Color_RGB(0, 0, 0));
	// Fuente Helvetica
	$pagina->setFont($font, $tamaño_letra); 
	$pagina->setStyle($estilo);
	
	return $pagina;
}

$pdf_glyphs = 0.0119853355894; // Proporción entre medidas entre pdf y glyphs (medidas para ttf)
$margen = 20;
$tamaños = array();
$y_linea = $margen;
$tamaño_letra = 12; // 12pt = 1em
$proporcion_letra = $tamaño_letra/12; // 12pt = 1em
$alto_letra = 12*$proporcion_letra;
$font = Zend_Pdf_Font::fontWithName(Zend_Pdf_Font::FONT_TIMES);

// Creamos el documento PDF
$pdf = new Zend_Pdf();

// Creamos una página
$page = creaPagina();
// Obtenemos el ancho y alto de la página
$ancho  = $page->getWidth();
$alto = $page->getHeight();

// Dibujamos la cabecera
$imagen = Zend_Pdf_ImageFactory::factory('sentidoweb.png');
$ancho_imagen = 50;
$alto_imagen = 50;
$page->drawImage($imagen, $margen, $alto-$y_linea-$alto_imagen, $margen+$ancho_imagen, $alto-$y_linea);

// Actualizo posición línea
$y_linea += $alto_imagen+$alto_letra;

// Escribimos el texto
$texto = $_POST["texto"];

$pos_texto = 0; // Para recorrer el texto
$linea = ""; // Para ir formando la linea actual
$long_linea = 0; // Longitud de la línea actual
$último_espacio = 0; // Posición del último espacio encontrado en la línea
$inicio_linea = 0; // Posición dentro del texto del inicio de la línea
$retorno_carro = false; // Para saber si hay un retorno de carro

// Ancho de la página en unidades glyphs
$ancho_pagina_glyphs = ($ancho-2*$margen) / $pdf_glyphs;

// Voy calculando las líneas y las escribo una a una
for ($i=0; $i<strlen($texto); $i++) {
	// Si no está guardado el tamaño de la letra lo almacenamos
	if (isset($tamaños[$texto[$i]]) === false) {
		$tamaños[$texto[$i]] = $font->widthForGlyph(
		  $font->cmap->glyphNumberForCharacter(
		    ord($texto[$i]))) * $proporcion_letra;
	}

	// Tratamos los retornos de carro
	if ($texto[$i] == "\n") { // || $texto[$i] == "\r") {
		// Realizamos el retorno de carro
		$retorno_carro = true;
	}

	// Si la longitud de la linea más el tamaño del 
	// caracter (glyph) es menor que el tamaño máximo
	// de la página entonces sigo creando la línea
	// en otro caso escribo la línea hasta el último 
	// espacio encontrado para no cortar las palabras
	if ($long_linea + $tamaños[$texto[$i]] < $ancho_pagina_glyphs && !$retorno_carro) {
		// Se puede añadir una letra

		// recalculo la longitud de la linea
		$long_linea += $tamaños[$texto[$i]];
		// Añado el caracter actual a la línea
		$linea .= $texto[$i];
		// Si es espacio o tabulador, almanceno la posicion
		// para no tener que cortar las palabras
		if ($texto[$i] == " " ||
		    //$texto[$i] == "\n" ||
			$texto[$i] == "\t") {
			$ultimo_espacio = $i-$inicio_linea;
		}
	} else {
		// Se debe dibujar la línea
		
		// Si es retorno de carro bajo una linea mas
		if ($retorno_carro) {
			$ultimo_espacio = $i-$inicio_linea+1;
		}
		// Si el espacio no es el ultimo caracter de la linea
		// paso la palabra actual a la siguiente linea
		$resto = "";
		if ($ultimo_espacio+$inicio_linea <= $i && $ultimo_espacio != 0) {
			// Cojo la última palabra para no recortarla
			$resto = substr($linea, $ultimo_espacio, strlen($linea)-$ultimo_espacio);
			// Quito la ultima palabra de la linea
			$linea = substr($linea, 0, $ultimo_espacio);
		}
		// Escribo el texto
		$page->drawText(trim($linea), $margen, $alto-$y_linea);
		// Incremento la posicion Y de la linea frente a la pagina
		$y_linea += $alto_letra*($retorno_carro? 2:1);
		// Salto de página
		if ($y_linea > $alto-2*$margen) {
			$page = creaPagina();
			$y_linea = $margen+$alto_letra;
		}
		// Calculo el tamaño de la linea que llevo despues de dibujar
		$long_linea = 0;
		// Si es retorno de carro empiezo una linea,
		// si no es asi, calculo el corte de palabra
		if ($retorno_carro) {
			$linea = "";
			$inicio_linea = $i;
		} else {
			for ($j=0; $j<strlen($resto); $j++) {
				$long_linea += $tamaños[$resto[$j]];
			}
		
			$long_linea += $tamaños[$texto[$i]];
			// Añado a la linea el caracter actual
			$linea = $resto.$texto[$i];
			// Posicion del inicio de la linea frente al texto general
			$inicio_linea = $i-strlen($resto);
		}
		$retorno_carro = false;
		$ultimo_espacio = 0;
	}
	
}

echo $pdf->render();

?>